"""
著作權所有 (C) 民國102年 意傳文化科技
開發者：薛丞宏
網址：http://意傳.台灣
語料來源：請看各資料庫內說明

本程式乃自由軟體，您必須遵照SocialCalc設計的通用公共授權（Common Public Attribution License, CPAL)來修改和重新發佈這一程式，詳情請參閱條文。授權大略如下，若有歧異，以授權原文為主：
	１．得使用、修改、複製並發佈此程式碼，且必須以通用公共授權發行；
	２．任何以程式碼衍生的執行檔或網路服務，必須公開該程式碼；
	３．將此程式的原始碼當函式庫引用入商業軟體，且不需公開非關此函式庫的任何程式碼

此開放原始碼、共享軟體或說明文件之使用或散佈不負擔保責任，並拒絕負擔因使用上述軟體或說明文件所致任何及一切賠償責任或損害。

臺灣言語工具緣起於本土文化推廣與傳承，非常歡迎各界用於商業軟體，但希望在使用之餘，能夠提供建議、錯誤回報或修補，回饋給這塊土地。

感謝您的使用與推廣～～勞力！承蒙！
"""
from 資料庫.整合.整合入言語 import 用流水號揣文字
from 資料庫.整合.整合入言語 import 用流水號揣關係
from 資料庫.整合.整合入言語 import 用流水號揣演化
from 資料庫.欄位資訊 import 版本正常
from 資料庫.整合.整合入言語 import 揣全部編修
from 資料庫.整合.整合入言語 import 揣全部文字
from 資料庫.整合.整合入言語 import 用流水號揣編修
from 字詞組集句章.解析整理工具.拆文分析器 import 拆文分析器
from 資料庫.欄位資訊 import 字詞
from 資料庫.欄位資訊 import 語句
from 資料庫.欄位資訊 import 章表冊
from 資料庫.欄位資訊 import 閩南語
from 資料庫.欄位資訊 import 國語臺員腔
from 資料庫.欄位資訊 import 文字
from 資料庫.整合.整合入言語 import 揣全部關係
from 資料庫.整合.整合入言語 import 揣全部演化

class 資料驗證(object):

	def __init__(self):
		self.編修檢查()
		self.關係演化流水號檢查()
		self.文字基本檢查()
	
	def 編修檢查(self):
		self.全部編修資料 = list(揣全部編修())
		self.流水號種類對照表 = {}
		for 編修目標流水號, 資料種類, 版本, 結果 in self.全部編修資料:
			if 編修目標流水號 in self.流水號種類對照表:
				print("無應該有重覆的流水號:{0}".format(編修目標流水號))
			self.流水號種類對照表[編修目標流水號] = 資料種類
		for 編修目標流水號, 資料種類, 版本, 結果 in self.全部編修資料:
			# 資料種類愛著
			# 結果佮本身愛仝一个種類
			
			if 資料種類 == '文字':
				目標資料 = 用流水號揣文字(編修目標流水號)
			elif 資料種類 == '關係':
				目標資料 = 用流水號揣關係(編修目標流水號)
			elif 資料種類 == '演化':
				目標資料 = 用流水號揣演化(編修目標流水號)
			else:
				目標資料 = None
			if 目標資料 == None:
				print("資料種類毋著:{0}，{1}".format(編修目標流水號, 資料種類))
			if 結果 != None:
				if 結果 not in self.流水號種類對照表:
					print("結果編號毋記著:{0}，{1}，結果：{2}"
						.format(編修目標流水號, 資料種類, 結果))
				if 資料種類 != self.流水號種類對照表[結果]:
					print("結果資料種類佮本身無合:{0}，{1}，結果：{2}，{3}"
						.format(編修目標流水號, 資料種類, 結果, self.流水號種類對照表[結果]))
			if 版本 != 版本正常:
				print("版本無正常，無定義:{0}"	.format(版本))
	
	def 文字基本檢查(self):
		# 閣愛檢查是毋是全部攏有佇編修內底
		# 閩南語有對齊無
		# 國語會使無音標，但是有音標嘛愛對齊
		# 無應該有--存在
		self.分析器 = 拆文分析器()
		self.全部文字 = list(揣全部文字())
		for 流水號, 來源, 種類, 腔口, 地區, 年代, 組合, 型體, 音標, 調變, 音變 in self.全部文字:
			if 用流水號揣編修(流水號) == None:
				print("文字資料無佇編修：{0}".format(流水號))
			if 腔口.startswith(閩南語):
				if 音標==None:
					print("閩南語文字資料無音標：{0}，{1}，{2}，{3}".format(流水號,來源, 型體, 音標))
				elif '--' in 音標:
					print("文字資料音標有「--」毋著：{0}，{1}，{2}".format(流水號, 型體, 音標))
				if 種類 == 字詞:
					self.分析器.產生對齊組(型體, 音標)
				elif 種類 == 語句:
					self.分析器.產生對齊句(型體, 音標)
				elif 種類 == 章表冊:
					self.分析器.產生對齊章(型體, 音標)
				else:
					print("文字資料種類毋著：{0}，{1}，{2}，{3}".format(流水號, 種類, 型體, 音標))
			elif 腔口.startswith(國語臺員腔):
				if 音標 == None:
					pass
				elif 種類 == 字詞:
					self.分析器.產生對齊組(型體, 音標)
				elif 種類 == 語句:
					self.分析器.產生對齊句(型體, 音標)
				elif 種類 == 章表冊:
					self.分析器.產生對齊章(型體, 音標)
				else:
					print("文字資料種類毋著：{0}，{1}，{2}，{3}".format(流水號, 種類, 型體, 音標))
			else:
				print("無支援的腔口：{0}，{1}，{2}，{3}，{4}".format(流水號, 種類, 腔口, 型體, 音標))
	
	def 文字組合檢查(self):
		# 有字典拄仔匯出組合猶袂全好
		# 佮組過組點攏做好矣
		# 兩種攏愛檢查
		# 組合可能會參考關係
		pass
		
	def 關係詞性檢查(self):
		# 閣愛檢查是毋是全部攏有佇編修內底
		# 愛看有走出奇怪的詞性無
		pass
	
	def 演化詞性檢查(self):
		# 閣愛檢查是毋是全部攏有佇編修內底
		# 愛看有走出奇怪的詞性無
		pass
		
	def 關係演化流水號檢查(self):
		# 流水號攏愛是文字的（查編修就好矣）
		self.全部關係 = list(揣全部關係())
		for 流水號, 甲流水號, 乙流水號, 乙對甲的關係類型, 關係性質, 詞性 in self.全部關係:
			if 用流水號揣編修(流水號) == None:
				print("關係資料無佇編修：{0}".format(流水號))
			if 甲流水號 not in self.流水號種類對照表:
				print("關係甲無佇編修：", 流水號, 甲流水號, 乙流水號)
			elif self.流水號種類對照表[甲流水號] != 文字:
				print("關係甲毋是文字：", 流水號, 甲流水號, 乙流水號)
			if 乙流水號 not in self.流水號種類對照表:
				print("關係乙無佇編修：", 流水號, 甲流水號, 乙流水號)
			elif self.流水號種類對照表[乙流水號] != 文字:
				print("關係乙毋是文字：", 流水號, 甲流水號, 乙流水號)
				
		self.全部演化 = list(揣全部演化())
		for 流水號, 甲流水號, 乙流水號, 乙對甲的演化類型, 解釋, 解釋流水號 in self.全部演化:
			if 用流水號揣編修(流水號) == None:
				print("演化資料無佇編修：{0}".format(流水號))
			if 甲流水號 not in self.流水號種類對照表:
				print("演化甲無佇編修：", 流水號, 甲流水號, 乙流水號)
			elif self.流水號種類對照表[甲流水號] != 文字:
				print("演化甲毋是文字：", 流水號, 甲流水號, 乙流水號)
			if 乙流水號 not in self.流水號種類對照表:
				print("演化乙無佇編修：", 流水號, 甲流水號, 乙流水號)
			elif self.流水號種類對照表[乙流水號] != 文字:
				print("演化乙毋是文字：", 流水號, 甲流水號, 乙流水號)

if __name__ == '__main__':
	資料驗證()
